
# line 7 "calc.y"

#define YYSTYPE double    /* data type of yacc stack */
#define QUIT    ( (double) 101010 )

#define NUMBER 257
#define UNARYMINUS 258
#ifndef YYSTYPE
#define YYSTYPE int
#endif
YYSTYPE yylval, yyval;
#define YYERRCODE 256

# line 45 "calc.y"


#include <stdio.h>
#include <ctype.h>

char *progname;       /* for error messages */
int  lineno = 1;

extern int yyparse( void );

void main( int, char ** );
int  yylex( void );
void prompt( void );
void yyerror( char * );
void warning( char *, char * );

void
main( int argc, char **argv )
{
     if (argc > 1) fprintf(stderr, "nonmeaningful arguments\n");
     progname = *argv;

     fprintf(stdout, "\n****************************************************\n");
     fprintf(stdout, "*      SACALC: a Simple Arithmetic Calculator      *\n");
     fprintf(stdout, "*                                                  *\n");
     fprintf(stdout, "*      1)at the prompt READY>                      *\n");
     fprintf(stdout, "*        you type in an expression, e.g. 1+2*3<CR> *\n");
     fprintf(stdout, "*        SACALC will evaluate the expression       *\n");
     fprintf(stdout, "*        and the result is displayed               *\n");
     fprintf(stdout, "*      2)to terminate the program                  *\n");
     fprintf(stdout, "*        type QUIT                                 *\n");
     fprintf(stdout, "*      3)if you make a mistake                     *\n");
     fprintf(stdout, "*        SACALC will complain and start over again *\n");
     fprintf(stdout, "*                                                  *\n");
     fprintf(stdout, "****************************************************\n\n\n");
     yyparse();
     fprintf(stdout, "\n****************************************************\n");
     fprintf(stdout, "*       SACALC: a Simple Arithmetic Calculator     *\n");
     fprintf(stdout, "*                                                  *\n");
     fprintf(stdout, "*       normal termination -- bye!                 *\n");
     fprintf(stdout, "****************************************************\n");

}

int yylex( void )
{
     int c;

     while ((c=getchar()) == ' ' || c == '\t' )
          ;
     if (c == EOF)
         return 0;
     if (c == '.' || isdigit(c)) {          /* number */
         ungetc(c, stdin);
         scanf("%lf", &yylval);
         return NUMBER;
     }
     if (c == '\n')
         lineno++;
     if (c == 'Q' || c == 'q')              /* ugly code */
         if ((c=getchar()) == 'U' || c == 'u')
             if ((c=getchar()) == 'I' || c == 'i')
                 if ((c=getchar()) == 'T' || c == 't') {
                     yylval = QUIT;
                     return( EOF );
                 }
                 else return '?';
     return( c );
}
void
yyerror( char *s )             /* called for yacc syntax error */
{
     warning(s, (void *) 0);
}

void
warning( char *s, char *t )            /* print warning message */
{
    fprintf(stderr, "%s: %s", progname, s);

    if (t) fprintf(stderr, " %s", t);

    fprintf(stderr, " near line %d\n", lineno);
}

void
prompt( void ) 
{
  fprintf(stdout, "READY> ");
}

const int yyexca[] = {
  -1, 1,
  0, -1,
  -2, 0,
  0,
};

#define YYNPROD 12
#define YYLAST 248

const int yyact[] = {
       2,       7,      13,      20,      11,       9,       6,      10,
       8,      12,      11,       3,       1,       0,       0,      12,
       0,       0,      14,      15,       0,      16,      17,      18,
      19,       0,       0,       0,       0,       0,       7,       0,
       0,       0,       0,       6,       0,       0,       0,       0,
      11,       9,       0,      10,       0,      12,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       5,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       4,       5,
};

const int yypact[] = {
   -4096,     -10,   -4096,      -2,      -8,   -4096,     -39,     -39,
   -4096,     -39,     -39,     -39,     -39,   -4096,   -4096,     -38,
     -32,     -32,   -4096,   -4096,   -4096,
};

const int yypgo[] = {
       0,      12,      11,
};

const int yyr1[] = {
       0,       1,       1,       1,       1,       2,       2,       2,
       2,       2,       2,       2,
};

const int yyr2[] = {
       0,       0,       2,       3,       3,       1,       2,       3,
       3,       3,       3,       3,
};

const int yychk[] = {
   -4096,      -1,      10,      -2,     256,     257,      45,      40,
      10,      43,      45,      42,      47,      10,      -2,      -2,
      -2,      -2,      -2,      -2,      41,
};

const int yydef[] = {
       1,      -2,       2,       0,       0,       5,       0,       0,
       3,       0,       0,       0,       0,       4,       6,       0,
       7,       8,       9,      10,      11,
};


/* pcyacc LALR parser driver routine */
/* This example default skeleton will not support ASTFLAG */
/* modified to support PCYACC YDB */

#ifndef INITIALIZE
#define INITIALIZE
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 200 /* default stack depth */
#endif

#ifndef yyerrok
#define yyerrok ((int) 0)
#endif

#define YYFLAG -1000 /* was -1000 */
#define YYERROR goto yyerrlab
#define YYACCEPT return(0)
#define YYABORT return(1)

YYSTYPE yyv[YYMAXDEPTH];
int token = -1; /* input token */
int errct = 0;  /* error count */
int errfl = 0;  /* error flag */

#include <stdio.h>

yyparse()
{ int yys[YYMAXDEPTH];
  int yyj, yym;
  YYSTYPE *yypvt;
  int yystate, *yyps, yyn;
  int tmptoken;

FILE *fydb;

#ifdef YYSHORT
  const short *yyxi;
#else  
  const int *yyxi;
#endif

  YYSTYPE *yypv;

  yystate = 0;
  token = -1;
  errct = 0;
  errfl = 0;
  yyps= &yys[-1];
  yypv= &yyv[-1];

  tmptoken = -1;
  fydb = fopen( "ydb.err", "w" );

     yystack:    /* put a state and value onto the stack */

fprintf(fydb, "at state %d, next token %d\n", yystate, tmptoken);

     if( ++yyps> &yys[YYMAXDEPTH-1] ) { 
     yyerror( "yacc stack overflow" ); 
     fclose ( fydb );
     return(1); 
     }

    *yyps = yystate;
    ++yypv;
    *yypv = yyval;

  yynewstate:

    yyn = yypact[yystate];

    if( yyn<= YYFLAG ) goto yydefault; /* simple state */

    if( token<0 ) if( (token=yylex())<0 ) token=0;
    if( (yyn += token)<0 || yyn >= YYLAST ) goto yydefault;

    if( yychk[ yyn=yyact[ yyn ] ] == token ){ /* valid shift */
tmptoken  = token;
      token = -1;
      yyval = yylval;
      yystate = yyn;
      if( errfl > 0 ) --errfl;
      goto yystack;
    }

 yydefault:

    if( (yyn=yydef[yystate]) == -2 ) {

      if( token<0 ) if( (token=yylex())<0 ) token = 0;

      /* look through exception table */

      for( yyxi=yyexca; (*yyxi!= (-1)) || (yyxi[1]!=yystate) ; yyxi += 2 ) ; /* VOID */

      while( *(yyxi+=2) >= 0 ){
        if( *yyxi == token ) break;
      }
      if( (yyn = yyxi[1]) < 0 ) {
           fclose ( fydb );
           return(0);   /* accept */
      }
    }

    if( yyn == 0 ){ /* error */

      switch( errfl ){
      	case 0:   /* brand new error */
          yyerror( "syntax error" );
      	  yyerrlab:
          ++errct;

       	case 1:
	  case 2: /* incompletely recovered error ... try again */
	    errfl = 3;

	    /* find a state where "error" is a legal shift action */

	    while ( yyps >= yys ) {
	      yyn = yypact[*yyps] + YYERRCODE;
	      if( yyn>= 0 && yyn < YYLAST && yychk[yyact[yyn]] == YYERRCODE ){
                yystate = yyact[yyn];  /* simulate a shift of "error" */
	        goto yystack;
	      }
	      yyn = yypact[*yyps];
	      /* the current yyps has no shift on "error", pop stack */

fprintf( fydb, "error: pop state %d, recover state %d\n", *yyps, yyps[-1]);

        --yyps;
	      --yypv;
	    }

	    /* there is no state on the stack with an error shift ... abort */

	yyabort:
      fclose ( fydb );
	    return(1);

      case 3:  /* no shift yet; clobber input char */

fprintf(fydb, "error: discard token %d\n", token);

	    if( token == 0 ) goto yyabort; /* don't discard EOF, quit */
	      token = -1;
	      goto yynewstate;   /* try again in the same state */
	    }
	  }

fprintf( fydb, "reduce with rule %d\n", yyn);

    /* reduction by production yyn */

	  yyps -= yyr2[yyn];
	  yypvt = yypv;
	  yypv -= yyr2[yyn];
	  yyval = yypv[1];
	  yym=yyn;
	  /* consult goto table to find next state */
	  yyn = yyr1[yyn];
	  yyj = yypgo[yyn] + *yyps + 1;
	  if( yyj>=YYLAST || yychk[ yystate = yyact[yyj] ] != -yyn ) yystate = yyact[yypgo[yyn]];
	    switch(yym){
	    	
case 1:
# line 21 "calc.y"
{ prompt(); } break;
case 2:
# line 23 "calc.y"
{ prompt(); } break;
case 3:
# line 25 "calc.y"
{ if (yypvt[-1] == QUIT) {
              return(0);
           } else {
             fprintf(stdout, "       RESULT ==========> %.8g\n", yypvt[-1]);
             prompt();
           }
         } break;
case 4:
# line 33 "calc.y"
{ yyerrok;
             prompt();
           } break;
case 5:
# line 37 "calc.y"
{ yyval = yypvt[-0]; } break;
case 6:
# line 38 "calc.y"
{ yyval = -yypvt[-0]; } break;
case 7:
# line 39 "calc.y"
{ yyval = yypvt[-2] + yypvt[-0]; } break;
case 8:
# line 40 "calc.y"
{ yyval = yypvt[-2] - yypvt[-0]; } break;
case 9:
# line 41 "calc.y"
{ yyval = yypvt[-2] * yypvt[-0]; } break;
case 10:
# line 42 "calc.y"
{ yyval = yypvt[-2] / yypvt[-0]; } break;
case 11:
# line 43 "calc.y"
{ yyval = yypvt[-1]; } break;
	    }
	    goto yystack;  /* stack new state and value */

	}

