/**********************************************************************
*                                                                     *
*  dcalc.y: PCYACC grammar description for Simple Calculator          *
*                                                                     *
*  By Y. Jenny Luo                                                    *
*                                                                     *
*  PCYACC (R) is a software product of ABRAXAS SOFTWARE INC.          *
*  Copyright (C) 1986-1996 by ABRAXAS SOFTWARE INC.                   *
*                                                                     *
**********************************************************************/

%{

/**********************************************************************
*                                                                     *
*  dcalc.cpp: parser for Simple Calculator                            *
*                                                                     *
*  Description: This file is generated by YACC according to the       *
*               grammar description file dcalc.y                      *
*                                                                     *
*  By Y. Jenny Luo                                                    *
*                                                                     *
*  PCYACC (R) is a software product of ABRAXAS SOFTWARE INC.          *
*  Copyright (C) 1986-1996 by ABRAXAS SOFTWARE INC.                   *
*                                                                     *
**********************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <ctype.h>
#include "public.h"

/* #define YYDEBUG */

int yyerrcnt = 0;
double result;

void prompt(void);
extern void yyerror(char *s, char *t, char *YYTEXT);

%}

%union
{
  double db;
  int i;
  char *str;
}


%token          NUMBER
%token          IDENTIFIER
%token          SQRT
%token          Shift

%left           '-' '+'
%left           '*' '/'
%left           '(' ')'
%left           '='
%left           Shift
%nonassoc       UMINUS

%start list

%%

list
  : expression   
    {
	  if (div_zero==1 || idn_no_value==1 || sqrt_neg==1 ||
	      (symtab_entry!=NULL && strlen(symtab_entry->value.ch)!=0)) ;
	  else
	  { 
	    result = $1.db;
	  } 
	}
  | IDENTIFIER '=' expression	%prec Shift			 
	{
		symtab_entry = mysymtab.lookupSymbol(get_symbol($1.str), 0);
		if (symtab_entry==NULL)
			printf("No such symbol %s in symbol table\n", $1.str);
		if (symtab_entry!=NULL) 
		{
			if (symtab_entry->value.ch!=NULL) ;
			else
			  result = symtab_entry->value.db;
		}
		else
		{
			strcpy(symbol_value.ch, get_symbol($1.str));
 	        mysymtab.addSymbol(get_symbol($1.str), ATTR_VAR, 0, symbol_value, 0);
		}		    
	  
		if ($3.str==NULL)
		{
			symtab_entry = mysymtab.lookupSymbol(get_symbol($1.str), 0);
			if (symtab_entry == NULL)
 				yyerror("NUMBER can not appear at the left side of =", 0, 0);	
			else
			{
				symtab_entry->attribute = ATTR_VAR;  
				symtab_entry->type = TYPE_DOUBLE;
				symtab_entry->value.db = $3.db;
				$1.db = $3.db;
				$$.db = $3.db;
				result = $3.db;
			}
		}
		else if ($3.str!=NULL)
		{
			if (sqrt_flag==1)
			{
				symtab_entry = mysymtab.lookupSymbol(get_symbol($1.str), 0);
				if (symtab_entry == NULL)
 					yyerror("NUMBER can not appear at the left side of =", 0, 0);	
				else
				{
					symtab_entry->attribute = ATTR_VAR;  
					symtab_entry->type = TYPE_DOUBLE;
					symtab_entry->value.db = $3.db;
					$1.db = $3.db;
					$$.db = $3.db;
					result = $3.db;
				}
			}
			else
			{
				symtab_entry = mysymtab.lookupSymbol($3.str, 0);
				if (symtab_entry==NULL)
					printf("IDENTIFIER at the right side of = can not be found in symbol table\n");
				else
				{
					if (strlen(symtab_entry->value.ch)!=0)  
						; /* no value associated with */
					else
					{
						$1.db = symtab_entry->value.db;
						$$.db = $1.db;
						result = $1.db;
						symtab_entry = mysymtab.lookupSymbol($1.str, 0);
						symtab_entry->attribute = ATTR_VAR;
						symtab_entry->type = TYPE_DOUBLE;
						symtab_entry->value.db = $1.db;
					}
				}
			}
		}
	}
  ;

expression
  : SQRT '(' expression ')'		
	{
		if ($3.str!=NULL)
		{
			symtab_entry = mysymtab.lookupSymbol(get_symbol($3.str), 0);
			if (symtab_entry==NULL)
				printf("IDENTIFIER at the right side of = can not be found in symbol table\n");
			else
			{
				if (strlen(symtab_entry->value.ch)!=0)
				{  
					$$.db  = symtab_entry->value.db; /* no value associated with */
					sqrt_flag = 1;
				}
				else
				{
					sqrt_flag = 1;
					$$.db = sqrt(symtab_entry->value.db);
					result = $$.db;
				}
			}
		}
		else
		{
			if ($3.db<0)
			{
				yyerror("The content of SQRT is negative value.", 0, 0);
				sqrt_neg = 1; 
			}
			else
			{
				sqrt_flag = 1;
				$$.db = sqrt($3.db);
			}
		}
	}
  | expression '+' expression		
	{ 
		/*$$.db = $1.db + $3.db; */
		if (sqrt_flag==1)
			$$.db = $1.db + $3.db;
		else if ($1.str==NULL && $3.str==NULL) /* NUMBER+NUMBER */
		{
			$$.db = $1.db + $3.db;
		}
		else if ($1.str==NULL && strlen($3.str)!=0) /* NUMBER+IDENTIFIER */
		{
			symtab_entry = mysymtab.lookupSymbol(get_symbol($3.str), 0);
			if (symtab_entry==NULL)
				yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
			else
			{
				if (strlen(symtab_entry->value.ch)!=0)
				{
					yyerror("IDENTIFIER does not have value", 0, 0);
					idn_no_value = 1;
				}
				else
				{
					$3.db = symtab_entry->value.db;
					$$.db = $1.db + $3.db;
				}
			}
		}
		else if (strlen($1.str)!=0 && strlen($3.str)==0) /* IDENTIFIER+NUMBER */
		{
			symtab_entry = mysymtab.lookupSymbol(get_symbol($1.str), 0);
			if (symtab_entry==NULL)
				yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
			else
			{
				if (strlen(symtab_entry->value.ch)!=0)
				{
					yyerror("IDENTIFIER does not have value", 0, 0);
					idn_no_value = 1;
				}
				else
				{
					$1.db = symtab_entry->value.db;
					$$.db = $1.db + $3.db;
				}
			}
		}
		else if (strlen($1.str)!=0 && $3.str!=NULL) /* IDENTIFIER+IDENTIFIER */
		{
			symtab_entry = mysymtab.lookupSymbol(get_symbol($1.str), 0);
			if (symtab_entry==NULL)
				yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
			else
			{
				if (strlen(symtab_entry->value.ch)!=0)
				{
					yyerror("IDENTIFIER does not have value", 0, 0);
					idn_no_value = 1;
				}
				else
				{
					$1.db = symtab_entry->value.db;
					symtab_entry = mysymtab.lookupSymbol(get_symbol($3.str), 0);
					if (symtab_entry==NULL)
						yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
					else
					{
						if (strlen(symtab_entry->value.ch)!=0)
						{
							yyerror("IDENTIFIER does not have value", 0, 0);
							idn_no_value = 1;
						}
						else
						{
							$3.db = symtab_entry->value.db;
							$$.db = $1.db + $3.db;
						}
					}
				}
			}
		}
	}
  | expression '-' expression	  
    { 
		/*$$.db = $1.db - $3.db;*/ 
		if ($1.str==NULL && $3.str==NULL) /* NUMBER-NUMBER */
		{
			$$.db = $1.db - $3.db;
		}
		else if ($1.str==NULL && $3.str!=NULL) /* NUMBER-IDENTIFIER */
		{
			symtab_entry = mysymtab.lookupSymbol(get_symbol($3.str), 0);
			if (symtab_entry==NULL)
				yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
			else
			{
				if (symtab_entry->value.ch!=NULL)
				{
					yyerror("IDENTIFIER does not have value", 0, 0);
					idn_no_value = 1;
				}
				else
				{
					$3.db = symtab_entry->value.db;
					$$.db = $1.db - $3.db;
				}
			}
		}
		else if ($1.str!=NULL && $3.str==NULL) /* IDENTIFIER-NUMBER */
		{
			symtab_entry = mysymtab.lookupSymbol(get_symbol($1.str), 0);
			if (symtab_entry==NULL)
				yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
			else
			{
				if (symtab_entry->value.ch!=NULL)
				{
					yyerror("IDENTIFIER does not have value", 0, 0);
					idn_no_value = 1;
				}
				else
				{
					$1.db = symtab_entry->value.db;
					$$.db = $1.db - $3.db;
				}
			}
		}
		else if ($1.str!=NULL && $3.str!=NULL) /* IDENTIFIER-IDENTIFIER */
		{
			symtab_entry = mysymtab.lookupSymbol(get_symbol($1.str), 0);
			if (symtab_entry==NULL)
				yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
			else
			{
				if (symtab_entry->value.ch!=NULL)
				{
					yyerror("IDENTIFIER does not have value", 0, 0);
					idn_no_value = 1;
				}
				else
				{
					$1.db = symtab_entry->value.db;
					symtab_entry = mysymtab.lookupSymbol(get_symbol($3.str), 0);
					if (symtab_entry==NULL)
						yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
					if (symtab_entry->value.ch!=NULL)
					{
						yyerror("IDENTIFIER does not have value", 0, 0);
						idn_no_value = 1;
					}
					else
					{
						$3.db = symtab_entry->value.db;
						$$.db = $1.db - $3.db;
					}
				}
			}
		}
	}
  | expression '*' expression		   
    { 
		/*$$.db = $1.db * $3.db;*/ 
		if ($1.str==NULL && $3.str==NULL) /* NUMBER*NUMBER */
		{
			$$.db = $1.db * $3.db;
		}
		else if ($1.str==NULL && $3.str!=NULL) /* NUMBER*IDENTIFIER */
		{
			symtab_entry = mysymtab.lookupSymbol(get_symbol($3.str), 0);
			if (symtab_entry==NULL)
				yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
			else
			{
				if (symtab_entry->value.ch!=NULL)
				{
					yyerror("IDENTIFIER does not have value", 0, 0);
					idn_no_value = 1;
				}
				else
				{
					$3.db = symtab_entry->value.db;
					$$.db = $1.db * $3.db;
				}
			}
		}
		else if ($1.str!=NULL && $3.str==NULL) /* IDENTIFIER*NUMBER */
		{
			symtab_entry = mysymtab.lookupSymbol(get_symbol($1.str), 0);
			if (symtab_entry==NULL)
				yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
			else
			{
				if (symtab_entry->value.ch!=NULL)
				{
					yyerror("IDENTIFIER does not have value", 0, 0);
					idn_no_value = 1;
				}
				else
				{
					$1.db = symtab_entry->value.db;
					$$.db = $1.db * $3.db;
				}
			}
		}
		else if ($1.str!=NULL && $3.str!=NULL) /* IDENTIFIER*IDENTIFIER */
		{
			symtab_entry = mysymtab.lookupSymbol(get_symbol($1.str), 0);
			if (symtab_entry==NULL)
				yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
			else
			{
				if (symtab_entry->value.ch!=NULL)
				{
					yyerror("IDENTIFIER does not have value", 0, 0);
					idn_no_value = 1;
				}
				else
				{
					$1.db = symtab_entry->value.db;
					symtab_entry = mysymtab.lookupSymbol(get_symbol($3.str), 0);
					if (symtab_entry==NULL)
						yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
					if (symtab_entry->value.ch!=NULL)
					{
						yyerror("IDENTIFIER does not have value", 0, 0);
						idn_no_value = 1;
					}
					else
					{
						$3.db = symtab_entry->value.db;
						$$.db = $1.db * $3.db;
					}
				}
			}
		}
	}
  | expression '/' expression	
	{
		if ($3.db==0)
		{
			yyerror("divided by zero", 0, 0);
			div_zero = 1;
		}
		else
		{
			/*$$.db = $1.db / $3.db;*/
			if ($1.str==NULL && $3.str==NULL) /* NUMBER/NUMBER */
			{
				$$.db = $1.db / $3.db;
			}
			else if ($1.str==NULL && $3.str!=NULL) /* NUMBER/IDENTIFIER */
			{
				symtab_entry = mysymtab.lookupSymbol(get_symbol($3.str), 0);
				if (symtab_entry==NULL)
					yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
				else
				{
					if (symtab_entry->value.ch!=NULL)
					{
						yyerror("IDENTIFIER does not have value", 0, 0);
						idn_no_value = 1;
					}
					else
					{
						$3.db = symtab_entry->value.db;
						$$.db = $1.db / $3.db;
					}
				}
			}
			else if ($1.str!=NULL && $3.str==NULL) /* IDENTIFIER/NUMBER */
			{
				symtab_entry = mysymtab.lookupSymbol(get_symbol($1.str), 0);
				if (symtab_entry==NULL)
					yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
				else
				{
					if (symtab_entry->value.ch!=NULL)
					{
						yyerror("IDENTIFIER does not have value", 0, 0);
						idn_no_value = 1;
					}
					else
					{
						$1.db = symtab_entry->value.db;
						$$.db = $1.db / $3.db;
					}
				}
			}
			else if ($1.str!=NULL && $3.str!=NULL) /* IDENTIFIER/IDENTIFIER */
			{
				symtab_entry = mysymtab.lookupSymbol(get_symbol($1.str), 0);
				if (symtab_entry==NULL)
					yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
				else
				{
					if (symtab_entry->value.ch!=NULL)
					{
						yyerror("IDENTIFIER does not have value", 0, 0);
						idn_no_value = 1;
					}
					else
					{
						$1.db = symtab_entry->value.db;
						symtab_entry = mysymtab.lookupSymbol(get_symbol($3.str), 0);
						if (symtab_entry==NULL)
							yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
						if (symtab_entry->value.ch!=NULL)
						{
							yyerror("IDENTIFIER does not have value", 0, 0);
							idn_no_value = 1;
						}
						else
						{
							$3.db = symtab_entry->value.db;
							$$.db = $1.db / $3.db;
						}
					}
				}
			}
		}
	}
  | '-' expression				%prec UMINUS    
    { 
		/* $$.db = -$2.db; */
		if ($2.str==NULL)     /* expr is NUMBER */
		{
			$$.db = -$2.db;
		}
		else					/* expr is IDENTIFIER */ 
		{
			symtab_entry = mysymtab.lookupSymbol(get_symbol($2.str), 0);
			if (symtab_entry==NULL)
				yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
			else
			{
				if (symtab_entry->value.ch!=NULL)
				{
					yyerror("IDENTIFIER does not have value", 0, 0);
					idn_no_value = 1;
				}
				else
				{
					$2.db = symtab_entry->value.db;
  					$$.db = -$2.db;
				}
			}
		} 
	}
  | '(' expression ')'          { $$.db = $2.db; }  
  | NUMBER			                      
	{ 
		$$.db = $1.db;
		symbol_value.db = $1.db;
	} 
  | IDENTIFIER		
	{
		symtab_entry = mysymtab.lookupSymbol(get_symbol($1.str), 0);
		if (symtab_entry==NULL)
			printf("No such symbol %s in symbol table\n", $1.str);
		if (symtab_entry!=NULL) 
		{
			if (strlen(symtab_entry->value.ch)!=0)
			{
				idn_no_value = 1; 
				strcpy($$.str, $1.str);
			}
			else
				$$.db = symtab_entry->value.db;
		}
		else
		{
			idn_no_value = 1;
		    strcpy(symbol_value.ch, $1.str);
			/*strcpy($$.str, $1.str);*/
 	        mysymtab.addSymbol(get_symbol($1.str), ATTR_VAR, 0, symbol_value, 0);
		}		    
	}
  ;

%%
#include "pcy_sk.hpp"
#include "pcl_sk.hpp"
#include "abxsym.hpp"

#define text_string_length 100
char text_string[text_string_length];

int div_zero = 0;		/* flag to remember divider is 0 */
int idn_no_value = 0;	/* flag to indicate variable does not have value */
int sqrt_neg = 0;		/* flag to indicate the content of SQRT 
							is negative value*/
int sqrt_flag = 0;		/* if sqrt expression, set it. */

union ABXVALUE symbol_value;
struct ABXsymtabentry *symtab_entry;

ABXSymbolTable mysymtab;

char * get_symbol(char *str)
{
	int i= 0, ch;
	static char buf[100];

	if (str!=NULL)
	{
		ch = str[i];
		while (ch!='=' && ch!='+' && ch!='-' && ch!='*' && ch!='/' && !isspace(ch) && ch!='\0')
		{
			i++;
			ch = str[i];
		}
		str[i] = '\0';
		strcpy(buf, str);
		return buf;
	}
	return NULL;
}

void main(int argc, char **argv)
{
	char buf[LINEWIDTH];

	if (argc > 1) cerr << "nonmeaningful arguments" << endl;

	cout << endl;
	cout << "*************************************************" << endl;
	cout << "*  SACALC: a Simple Arithmetic Calculator       *" << endl;
	cout << "*                                               *" << endl;
	cout << "*  1) at prompt READY>                          *" << endl;
	cout << "*     you type in an expression, e.g. 1+2*3<CR> *" << endl;
    cout << "*     SACALC will evaluate the expression       *" << endl;
	cout << "*     and the result is displayed               *" << endl;
	cout << "*  2) to terminate the program                  *" << endl;
	cout << "*     type QUIT                                 *" << endl;
	cout << "*  3) if you make a mistake                     *" << endl;
	cout << "*     SACALC will complain and start over again *" << endl;
	cout << "*                                               *" << endl;
	cout << "*************************************************" << endl << endl << endl;

	mysymtab.initSymbolTable();


	while (1)
	{
		prompt();
		cin.getline(buf, LINEWIDTH);
		/* check "QUIT" */
		if (strlen(buf)==4)
		{
			if (buf[0]=='Q' || buf[0]=='q')
			{
				if (buf[1]=='U' || buf[1]=='u')
				{
					if (buf[2]=='I' || buf[2]=='i')
					{
						if (buf[3]=='T' || buf[3]=='t')
						{
							cout << endl;
							cout << "*************************************************" << endl;
							cout << "*  SACALC: a Simple Arithmetic Calculator       *" << endl;
							cout << "*                                               *" << endl;
							cout << "*  normal termination -- byte!                  *" << endl;
							cout << "*************************************************" << endl;
							break;  
						}
					}
				}
			}
		}
	
		ABXLex* mylex = new ABXLex(buf);
		ABXYacc* myyacc = new ABXYacc(mylex);
		myyacc->yyParse();
		yyerrcnt = myyacc->get_yyErrorCount();

		if (yyerrcnt != 0)
		{
			cerr << endl << endl;
			cerr << "<====    " << yyerrcnt;
			if (yyerrcnt == 1)
				cerr << " error";
			else
				cerr << " errors";
			cerr << " found by the parser    ====>" << endl << endl << endl;
		}
		else
		{
			if (div_zero==0 && idn_no_value==0 && sqrt_neg==0 &&
			    (symtab_entry!=NULL && symtab_entry->value.ch==NULL))
			{
				cout << endl << "    RESULT ====> " << result;			
				cout << endl << endl << endl;
				cout << "<====    No syntax error was found by the parser    ====>";
				cout << endl << endl << endl; 
			}
			else if (symtab_entry==NULL && idn_no_value==0)   /*only for number arithmetic */
			{
				cout << endl << "    RESULT ====> " << result;			
				cout << endl << endl << endl;
				cout << "<====    No syntax error was found by the parser    ====>";
				cout << endl << endl << endl; 
			}
			else if (idn_no_value==0)
			{
				cout << endl << "    RESULT ====> " << result;			
				cout << endl << endl << endl;
				cout << "<====    No syntax error was found by the parser    ====>";
				cout << endl << endl << endl; 
			}
			else
			{
			    div_zero = 0;
				idn_no_value = 0;
				sqrt_neg = 0;
				sqrt_flag = 0;
				cout << endl << endl;
			}
		}
		delete myyacc;
	}
}

void prompt(void)
{
	cout << "READY> ";
}
