
%{
#include <fstream.h>
#include "defs.h"
%}

%union {
  int   in;
  char *ch;
}

%token DRAW DEFINE                              /* verbs      */
%token LINE BOX ELLIPSE POLYGON                 /* shapes     */
%token OUTLINED SOLID DOTTED            /* attributes */
%token WHITE GRAY BLACK RED GREEN BLUE  /* colors         */

%token <ch> IDENTIFIER
%token <in> INTEGER

%start stats

%%

stats
  :
  |  stats stat
  ;

stat
  :  draw_stat   ';'
  |  define_stat ';'
  ;

draw_stat
  :  DRAW IDENTIFIER
		{ append_objlst(lookup($2)); 
		  delete yylval.ch;
		}
  |  DRAW object
		{ append_objlst(new_object(&anObject)); }
  ;

define_stat
  :  DEFINE IDENTIFIER '=' object
		{ install($2, new_object(&anObject)); 
		}
  ;

object
  :  shape attrs '(' params ')'
  ;

shape
  :  LINE    { anObject.shape = LINE; }
  |  BOX     { anObject.shape = BOX;  }
  |  POLYGON { anObject.shape = POLYGON; }
  |  ELLIPSE { anObject.shape = ELLIPSE; }
  ;

attrs
  :
  |  attrs attr
  ;

attr
  :  style
  |  color
  ;

style
  :  SOLID  { anObject.style = SOLID; }
  |  DOTTED { anObject.style = DOTTED; }
  ;

color
  :  WHITE { anObject.color = RGB_WHITE; }
  |  GRAY  { anObject.color = RGB_GRAY;  }
  |  BLACK { anObject.color = RGB_BLACK; }
  |  RED   { anObject.color = RGB_RED;   }
  |  GREEN { anObject.color = RGB_GREEN; }
  |  BLUE  { anObject.color = RGB_BLUE;  }
  ;

params
  :  point
  |  params ',' point
  ;

point
  :  INTEGER INTEGER
		{
		anObject.x_coord[anObject.npoints  ] = $1;
		anObject.y_coord[anObject.npoints++] = $2;
		}
  ;

%%
