
/*******************************************************************
*                                                                  *
*  lex.l: scanner description for Simple Calculator                *
*                                                                  *
*  By Y. Jenny Luo                                                 *
*                                                                  *
*  PCYACC (R) is a software product of ABRAXAS SOFTWARE INC.       *
*  Copyright (C) 1986-1996 by ABRAXAS SOFTWARE INC.                *
*                                                                  *
*******************************************************************/

%{

/*******************************************************************
*                                                                  *
*  lex.c: lexical analyzer for Simple Calculator                   *
*                                                                  *
*  By Y. Jenny Luo                                                 *
*                                                                  *
*  PCYACC (R) is a software product of ABRAXAS SOFTWARE INC.       *
*  Copyright (C) 1986-1996 by ABRAXAS SOFTWARE INC.                *
*                                                                  *
*******************************************************************/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "public.h"             /* define global information */
#include "dcalc.h"               /* header file generated by PCYACC */


#define LEX_DEBUG       1
#define YYERRCODE       256
#define LINEWIDTH       80


unsigned char yytext[TEXTLEN];   /* current token's text */
extern FILE *yyin;              /* pointer to input stream defined
				   in main.c */
extern char yyerrsrc[];         /* input filename defined in main.c */
extern int yyerrcnt;            /* count of error, defined in err_skel.c */

extern FILE *yyerrfile;

char* yydisplay(int tokenvalue); /* display the token based on tokenvalue */

int yylineno = -1;              /* current line number */
int headerflag = 0;             /* set to indicate the next header format
				   will be treated as comment. */

%}

digit           [0-9]
blank           [ \t]
sign            [+-/*]
other           .

%%

{digit}+        {
		  sscanf(yytext, "%lf", &yylval.db);
		  return NUMBER;
		}

{digit}+\.{digit}*	{
				  sscanf(yytext, "%lf", &yylval.db);
				  return NUMBER;
				}

\.{digit}+		{
				  sscanf(yytext, "%lf", &yylval.db);
				  return NUMBER;
				}


sign            return *yytext;    

{blank}+                ;

{other}                 return yytext[0];

%%

/*********************************************************************
*  FUNCTION: yydisplay                                               *
*  PARAMETER: int                                                    *
*  RETURN: int                                                       *
*  DESCRIPTION: display the token based on the input tokenvalue      *
*********************************************************************/
char* yydisplay(int tokenvalue)
{
  static char buf[TEXTBUF];

  if (tokenvalue==NUMBER)
    return "NUMBER";

  switch (tokenvalue)
  {
    case '\a':  return ("[\\a]");
    case '\b':  return ("[\\b]");
    case '\v':  return ("[\\v]");
    case '\f':  return ("[\\f]");
    case '\r':  return ("[\\r]");
    case '\t':  return ("[\\t]");
    case '\n':  return ("[\\n]");
  }

  if (tokenvalue == 0)
  {
    return ("[end of file]");
  }
  else if (tokenvalue == YYERRCODE)
  {
    return ("[error]");
  }

  if (isprint(tokenvalue))
  {
    sprintf(buf, "%c", tokenvalue);
    return buf;
  }
  else
  {
    sprintf(buf, "[char %d]", tokenvalue);
    return buf;
  }

}

