/*======================= PCYACC:  ======================================
           ABRAXAS SOFTWARE (R) PC YACC
       PCYACC (C) 1986-1991, ABRAXAS SOFTWARE, INC.
               all rights reserved
========================================================================*/


#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "param.h"

extern long  LineNumber;        /* The counter for counting the source code line.  */
                                /* It is defined in ytool.c                        */
extern char  TokenBuffer[];     /* The buffer for holding the content of current   */
                                /* token temporily.				   */
static char *ResWords[]=	/* Reserved words table,used for checking the res- */
            {			/* erved words.					   */
               "token",
               "left",
               "right",
               "start",
               "prec",
               "nonassoc",
/*               "type",
	       "union",       */
               "NULL"
            };
extern FILE   *SFile;	        /* Stream handle for sourcce YACC file, declared   */
				/* in ytool.c					   */

int Lex();

/* =============================================================================== */
/* Function    : int IsReservedWord(String)					   */
/*               char *String;							   */
/* Description : Determing if the parameter String is a reserved word or not.      */
/*               If it is a reserved word, the corresponding token value will be   */
/*               return,otherwise return 0 			                   */
/* =============================================================================== */
int IsReservedWord(String)
char *String;
{
  int i=0;
  while(1)
  {
     if (!strcmp(ResWords[i],String))
         break;
     if (!strcmp(ResWords[i],"NULL"))
         break;
       i++;
  };
  if (strcmp(ResWords[i],"NULL"))
      return (TOKEN+i);
  else return (0);
}


/* =============================================================================== */
/* Function    : int GetToken()            				           */
/*                                      				 	   */
/* Description : Forming a token according to the input stream,then return the     */
/*               token value. The content of this token is stored in array         */
/*               TokenBuffer[], The type of token value is INTEGER.                */
/* =============================================================================== */
int GetToken()
{
     int NotOK;
     int Token;

     if ((Token=Lex())!=LBRACE)
        return Token;
     NotOK=1;
     while (NotOK)
     {
         if((Token=Lex())==RBRACE)
                  NotOK--;
         else if(Token==LBRACE)
                 NotOK++;
     }
     return Token=Lex();
}

/* =============================================================================== */
/* Function    : int Lex()            				                   */
/*                                      				 	   */
/* Description : Scan the input stream and convert the input symbol into token,    */
/*               the return value of the function is an integer that represent the */
/*               the token.                                                        */
/* =============================================================================== */
int Lex()
{
   int  Value;
   int  NotOK=0;
   char LastCh;
   char Ch;
   char NextCh;
   char *Ptr;

   if ((Ch=fgetc(SFile))==EOF)
      return EOF;
relex:
   Ptr=TokenBuffer;
   while (Ch=='\t' ||  Ch==' ')
       Ch=fgetc(SFile);
   if (Ch==EOF)
       return EOF;
   if (isalpha(Ch) || Ch=='.')
   {
      do {
           *Ptr++=Ch;
           Ch=fgetc(SFile);
      } while  ((isalnum(Ch) || Ch=='.' || Ch=='_' ) && (Ch!=EOF));
      *Ptr='\0';
      ungetc(Ch,SFile);
      Value=IsReservedWord(TokenBuffer);
      if (!Value)
           Value= IDENTIFIER;
   } else switch(Ch)
          {
             case '\n':
                       LineNumber++;
                       Ch=fgetc(SFile);
                       goto relex;
             case '{':
                       *Ptr++=Ch;
                       *Ptr='\0';
                       Value=LBRACE;
                       break;
             case '}':
                       *Ptr++=Ch;
                       *Ptr='\0';
                       Value=RBRACE;
                       break;
             case '/':
                      if ((NextCh=fgetc(SFile))!='*')
                      {
                        ungetc(NextCh,SFile);
                        *Ptr++=Ch;
                        *Ptr='\0';
                        Value=(int)Ch;
                      }
                      else {
                               if ((Ch=fgetc(SFile))==EOF)
                               {
                                   fprintf(stderr,"nonend comment !\n");
                                   return EOF;
                               };
                               while (1)
                               {
                                   if  (((NextCh=fgetc(SFile))=='/') && (Ch=='*'))
                                      break;
                                   if (NextCh==EOF)
                                   {
                                       fprintf(stderr,"nonend comment !\n");
                                       return EOF;
                                   };
                                   if (NextCh=='\n')
                                       LineNumber++;
                                   Ch=NextCh;
                               };
                               NextCh=0;
                               Ch=fgetc(SFile);
                               goto relex;
                           }
                       break;
     	     case '\'':
                      LastCh=Ch;
                      do {
       		          *Ptr++=Ch;
                          Ch=fgetc(SFile);

                          if (LastCh=='\\' && Ch=='\'')
                              Ch=fgetc(SFile);

                          LastCh=Ch;
                      } while (Ch!=EOF && Ch!='\'');
		      if (Ch==EOF)
			{
			   fprintf(stderr,"String not end!\n");
                           return EOF;
			}
                      *Ptr++=Ch;
                      *Ptr='\0';
                      Value= STRING;
		      break;
             case '"':
                      LastCh=Ch;
                      do {
       		          *Ptr++=Ch;
                          Ch=fgetc(SFile);
                          if (LastCh=='\\' && Ch=='"')
                              Ch=fgetc(SFile);
                          LastCh=Ch;
                      } while (Ch!=EOF && Ch!='"');
		      if (Ch==EOF)
			{
			   fprintf(stderr,"String not end!\n");
                           return EOF;
			}
                      *Ptr++=Ch;
                      *Ptr='\0';
		      Value= STRING;
		      break;
             case '%':
                      NextCh=fgetc(SFile);
                      switch(NextCh)
                      {
                          case '{':
                                   Value=PERCENT_LBRACE;
                                   *Ptr++=Ch;
                                   *Ptr++=NextCh;
                                   *Ptr='\0';
                                   break;
                          case '}':
                                   Value=PERCENT_RBRACE;
                                   *Ptr++=Ch;
                                   *Ptr++=NextCh;
                                   *Ptr='\0';
                                   break;
                          case '%':
                                   Value=PERCENT_PERCENT;
                                   *Ptr++=Ch;
                                   *Ptr++=NextCh;
                                   *Ptr='\0';
                                   break;
                          default:
                                  *Ptr++=Ch;
                                  *Ptr='\0';
                                  ungetc(NextCh,SFile);
                                  Value=(int) Ch;
                                  break;
                      }
              break;
             default:
                       *Ptr++=Ch;
                       *Ptr='\0';
                       Value=(int) Ch;
                       break;
          }
    return Value;
}

