#include "pcl_sk.hpp"
#include "pcy_sk.hpp"

class ABXError
{
private:
	ABXLex *lexObject;
	ABXYacc *yaccObject;
	int yyErrCnt;
	char *yyErrSrc;
	FILE *yyErrFile;
	int yyErrLineNo;
	char *yyErrText;
public:
	ABXError(ABXLex *LexObject, ABXYacc *YaccObject);
	~ABXError();
	char *yyGetToken(int tokenvalue);
	int yyGetLineNumber(void);
	int yyGetErrorCount(void);
	void yyGetErrFileName(char *s);
	void yySetErrText(char *s);
	int yyGetCharNumber(void);
	int yyGetExpectedTokens(int *token_list);
	void yyErrPrefix(char *msg, char *YYTEXT);
	void yyError(char *s, char *t, char *YYTEXT);
	void yySkipToken(void);
	void yySkipSymbol(void);
	void yyReplaceToken(char *token);
	int yyMatchToken(char *token);
	void yyInsertToken(char *token);
};
