
# line 13 "dcalc.y"

/**********************************************************************
*                                                                     *
*  dcalc.cpp: parser for Simple Calculator                            *
*                                                                     *
*  Description: This file is generated by YACC according to the       *
*               grammar description file dcalc.y                      *
*                                                                     *
*  By Y. Jenny Luo                                                    *
*                                                                     *
*  PCYACC (R) is a software product of ABRAXAS SOFTWARE INC.          *
*  Copyright (C) 1986-1996 by ABRAXAS SOFTWARE INC.                   *
*                                                                     *
**********************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <ctype.h>
#include "public.h"

/* #define YYDEBUG */

int yyerrcnt = 0;
double result;

void prompt(void);
extern void yyerror(char *s, char *t, char *YYTEXT);


# line 46 "dcalc.y"
typedef union 
{
  double db;
  int i;
  char *str;
} YYSTYPE;
#define NUMBER 257
#define IDENTIFIER 258
#define SQRT 259
#define Shift 260
#define UMINUS 261
YYSTYPE yylval, yyval;
#define YYERRCODE 256

# line 570 "dcalc.y"

#include "pcy_sk.hpp"
#include "pcl_sk.hpp"
#include "abxsym.hpp"

#define text_string_length 100
char text_string[text_string_length];

int div_zero = 0;		/* flag to remember divider is 0 */
int idn_no_value = 0;	/* flag to indicate variable does not have value */
int sqrt_neg = 0;		/* flag to indicate the content of SQRT 
							is negative value*/
int sqrt_flag = 0;		/* if sqrt expression, set it. */

union ABXVALUE symbol_value;
struct ABXsymtabentry *symtab_entry;

ABXSymbolTable mysymtab;

char * get_symbol(char *str)
{
	int i= 0, ch;
	static char buf[100];

	if (str!=NULL)
	{
		ch = str[i];
		while (ch!='=' && ch!='+' && ch!='-' && ch!='*' && ch!='/' && !isspace(ch) && ch!='\0')
		{
			i++;
			ch = str[i];
		}
		str[i] = '\0';
		strcpy(buf, str);
		return buf;
	}
	return NULL;
}

void main(int argc, char **argv)
{
	char buf[LINEWIDTH];

	if (argc > 1) cerr << "nonmeaningful arguments" << endl;

	cout << endl;
	cout << "*************************************************" << endl;
	cout << "*  SACALC: a Simple Arithmetic Calculator       *" << endl;
	cout << "*                                               *" << endl;
	cout << "*  1) at prompt READY>                          *" << endl;
	cout << "*     you type in an expression, e.g. 1+2*3<CR> *" << endl;
    cout << "*     SACALC will evaluate the expression       *" << endl;
	cout << "*     and the result is displayed               *" << endl;
	cout << "*  2) to terminate the program                  *" << endl;
	cout << "*     type QUIT                                 *" << endl;
	cout << "*  3) if you make a mistake                     *" << endl;
	cout << "*     SACALC will complain and start over again *" << endl;
	cout << "*                                               *" << endl;
	cout << "*************************************************" << endl << endl << endl;

	mysymtab.initSymbolTable();


	while (1)
	{
		prompt();
		cin.getline(buf, LINEWIDTH);
		/* check "QUIT" */
		if (strlen(buf)==4)
		{
			if (buf[0]=='Q' || buf[0]=='q')
			{
				if (buf[1]=='U' || buf[1]=='u')
				{
					if (buf[2]=='I' || buf[2]=='i')
					{
						if (buf[3]=='T' || buf[3]=='t')
						{
							cout << endl;
							cout << "*************************************************" << endl;
							cout << "*  SACALC: a Simple Arithmetic Calculator       *" << endl;
							cout << "*                                               *" << endl;
							cout << "*  normal termination -- byte!                  *" << endl;
							cout << "*************************************************" << endl;
							break;  
						}
					}
				}
			}
		}
	
		ABXLex* mylex = new ABXLex(buf);
		ABXYacc* myyacc = new ABXYacc(mylex);
		myyacc->yyParse();
		yyerrcnt = myyacc->get_yyErrorCount();

		if (yyerrcnt != 0)
		{
			cerr << endl << endl;
			cerr << "<====    " << yyerrcnt;
			if (yyerrcnt == 1)
				cerr << " error";
			else
				cerr << " errors";
			cerr << " found by the parser    ====>" << endl << endl << endl;
		}
		else
		{
			if (div_zero==0 && idn_no_value==0 && sqrt_neg==0 &&
			    (symtab_entry!=NULL && symtab_entry->value.ch==NULL))
			{
				cout << endl << "    RESULT ====> " << result;			
				cout << endl << endl << endl;
				cout << "<====    No syntax error was found by the parser    ====>";
				cout << endl << endl << endl; 
			}
			else if (symtab_entry==NULL && idn_no_value==0)   /*only for number arithmetic */
			{
				cout << endl << "    RESULT ====> " << result;			
				cout << endl << endl << endl;
				cout << "<====    No syntax error was found by the parser    ====>";
				cout << endl << endl << endl; 
			}
			else if (idn_no_value==0)
			{
				cout << endl << "    RESULT ====> " << result;			
				cout << endl << endl << endl;
				cout << "<====    No syntax error was found by the parser    ====>";
				cout << endl << endl << endl; 
			}
			else
			{
			    div_zero = 0;
				idn_no_value = 0;
				sqrt_neg = 0;
				sqrt_flag = 0;
				cout << endl << endl;
			}
		}
		delete myyacc;
	}
}

void prompt(void)
{
	cout << "READY> ";
}
const int yyexca[] = {
  -1, 1,
  0, -1,
  -2, 0,
  0,
};

#define YYNPROD 12
#define YYLAST 223

const int yyact[] = {
       6,      12,      13,       6,       1,       5,       0,      10,
       5,      24,      10,       8,      11,       9,       0,      11,
      23,      10,       8,       0,       9,       0,      11,      10,
       8,       2,       9,       0,      11,       0,       0,      14,
      16,       0,      17,      18,      19,      20,      21,      22,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       7,      15,       4,       7,       3,       4,
};

const int yypact[] = {
     -37,   -4096,     -19,     -60,     -38,     -40,     -40,   -4096,
     -40,     -40,     -40,     -40,     -40,     -40,   -4096,   -4096,
     -25,     -35,     -35,   -4096,   -4096,     -19,     -32,   -4096,
   -4096,
};

const int yypgo[] = {
       0,       4,      25,
};

const int yyr1[] = {
       0,       1,       1,       2,       2,       2,       2,       2,
       2,       2,       2,       2,
};

const int yyr2[] = {
       0,       1,       3,       4,       3,       3,       3,       3,
       2,       3,       1,       1,
};

const int yychk[] = {
   -4096,      -1,      -2,     258,     259,      45,      40,     257,
      43,      45,      42,      47,      61,      40,      -2,     258,
      -2,      -2,      -2,      -2,      -2,      -2,      -2,      41,
      41,
};

const int yydef[] = {
       0,      -2,       1,      11,       0,       0,       0,      10,
       0,       0,       0,       0,       0,       0,       8,      11,
       0,       4,       5,       6,       7,       2,       0,       9,
       3,
};

#include <stdio.h>
#include "pcy_sk.hpp" 

extern char* yydisplay(int);

ABXYacc::ABXYacc(ABXLex* LexObject)
{
    lexObject = LexObject;
    yyValueStack = new YYSTYPE[YYMAXDEPTH];
    redSequence = new int[YYREDMAX];
    yyToken = -1;
    yyErrorFlag = 0;
    yyErrorCount = 0;
    redCount = 0;
}

ABXYacc::~ABXYacc()
{
    delete[] yyValueStack;
    delete[] redSequence;
}                                                               

int ABXYacc::yyParse(void)
{
#ifdef YYSHORT
    const short *yyxi;
#else
    const int *yyxi;
#endif
#ifdef YYASTFLAG
    int ti;
    int tj;
#endif

#ifdef YYDEBUG
int tmptoken;
#endif
    int statestack[YYMAXDEPTH]; /* state stack */
    int j,
	m;              /* working index */
    YYSTYPE *yypvt;
    int tmpstate,
	*yyps,
	n;
    YYSTYPE *yypv;


    tmpstate = 0;
    yyToken = -1;


#ifdef YYDEBUG
    tmptoken = -1;
#endif


    yyErrorCount = 0;
    yyErrorFlag = 0;
    yyps = statestack -1 ;
    yypv = yyValueStack - 1;

enstack:    /* push stack */
#ifdef YYDEBUG
    printf("at state %d, next token %d\n", tmpstate, tmptoken);
#endif
    if ( ++yyps - &statestack[YYMAXDEPTH-1] > 0)
    {
	yyerror("pcyacc internal stack overflow", 0, 0);
	return(1);
    }
    *yyps = tmpstate;
    ++yypv;
    *yypv = yyval;

newstate:
    n = yypact[tmpstate];
    if (n <= PCYYFLAG)
	goto defaultact; /*  a simple state */

    if (yyToken < 0)
	if ((yyToken=lexObject->yyLex()) < 0)
	    yyToken = 0;
	else if (yyToken>=0)    
      printf("tokenValue=[%d], actual token=[%s]\n",
	         yyToken, yydisplay(yyToken));  
    
    if ((n += yyToken) < 0 || n >= YYLAST)
	goto defaultact;


    if (yychk[n=yyact[n]] == yyToken)
    {    /* a shift */
#ifdef YYDEBUG
	tmptoken  = yyToken;
#endif
	yyToken = -1;
	yyval = yylval;
	tmpstate = n;
	if (yyErrorFlag > 0)
	    --yyErrorFlag;
	goto enstack;
    }

defaultact:


    if ((n=yydef[tmpstate]) == -2)
    {
	if (yyToken < 0)
	    if ((yyToken=lexObject->yyLex())<0)
		  yyToken = 0; 
	    else if (yyToken>=0)   
          printf("tokenValue=[%d], actual token=[%s]\n",
		         yyToken, yydisplay(yyToken)); 

	for (yyxi=yyexca; (*yyxi!= (-1)) || (yyxi[1]!=tmpstate); yyxi += 2)
	     ;
	while (*(yyxi+=2) >= 0)
	    if (*yyxi == yyToken)
		break;
	if ((n=yyxi[1]) < 0)
	{    /* an accept action */
#ifdef YYASTFLAG
	    yytfilep = fopen(yytfilen, "w");
	    if (yytfilep == NULL)
	    {
		fprintf(stderr, "Can't open t file: %s\n", yytfilen);
		return(0);          
	    }
	    for (ti=redcnt-1; ti>=0; ti--)
	    {
		tj = svdprd[redSequence[ti]];
		while (strcmp(svdnams[tj], "$EOP"))
		    fprintf(yytfilep, "%s ", svdnams[tj++]);
		fprintf(yytfilep, "\n");
	    }
	    fclose(yytfilep);
#endif

	    return (0);
	}
    }

    if (n == 0)
    {    /* error situation */
	switch (yyErrorFlag)
	{
	    case WAS0ERR:    /* an error just occurred */
		yyerror("Syntax error", yydisplay(yyToken), lexObject->get_yyText());
		if ((n=yypact[tmpstate])>PCYYFLAG && n<YYLAST)
		{
			register int x;
			for (x=(n>0)?n:0; x<YYLAST; ++x)
			{
				if (yychk[yyact[x]]==x-n && x-n!=YYERRCODE)
					yyerror(0, yydisplay(x-n), lexObject->get_yyText());
			}
			yyerror(0, 0, lexObject->get_yyText());
		}
		yyerror(0, 0, lexObject->get_yyText());
yyErrLab:
		++yyErrorCount;

	    case WAS1ERR:
	    case WAS2ERR:    /* try again */
		yyErrorFlag = 3;
		/* find a state for a legal shift action */
		while (yyps >= statestack)
		{
		    n = yypact[*yyps] + YYERRCODE;
		    if (n >= 0 && n < YYLAST && yychk[yyact[n]] == YYERRCODE)
		    {
			tmpstate = yyact[n];    /* simulate a shift of "error" */
			goto enstack;
		    }
		    n = yypact[*yyps];

		    /* the current yyps has no shift on "error", pop stack */
#ifdef YYDEBUG
		    printf("error: pop state %d, recover state %d\n", *yyps, yyps[-1]);
#endif
		    --yyps;
		    --yypv;
		}

yyabort:

#ifdef YYASTFLAG
		yytfilep = fopen(yytfilen, "w");
		if (yytfilep == NULL)
		{
		    fprintf(stderr, "Can't open t file: %s\n", yytfilen);
		    return(1);
		}
		for (ti=1; ti<redCount; ti++)
		{
		    tj = svdprd[redSequence[ti]];
		    while (strcmp(svdnams[tj], "$EOP"))
			fprintf(yytfilep, "%s ", svdnams[tj++]);
		    fprintf(yytfilep, "\n");
		}
		fclose(yytfilep);
#endif

		return(1);


	    case WAS3ERR:  /* clobber input char */
#ifdef YYDEBUG
		printf("error: discard token %d\n", yyToken);
#endif
		if (yyToken == 0) 
		    goto yyabort; /* quit */
		yyToken = -1;
		goto newstate;
	} /* switch */
    } /* if */

    /* reduction, given a production n */
#ifdef YYDEBUG
    printf("reduce with rule %d\n", n);
#endif
#ifdef YYASTFLAG
    if ( redCount<YYREDMAX )
	redSequence[redCount++] = n;
#endif
    yyps -= yyr2[n];
    yypvt = yypv;
    yypv -= yyr2[n];
    yyval = yypv[1];
    m = n;
    /* find next state from goto table */
    n = yyr1[n];
    j = yypgo[n] + *yyps + 1;
    if (j>=YYLAST || yychk[ tmpstate = yyact[j] ] != -n)
	tmpstate = yyact[yypgo[n]];
    switch (m)
    { /* actions associated with grammar rules */
	
case 1:
# line 72 "dcalc.y"
{
	  if (div_zero==1 || idn_no_value==1 || sqrt_neg==1 ||
	      (symtab_entry!=NULL && strlen(symtab_entry->value.ch)!=0)) ;
	  else
	  { 
	    result = yypvt[-0].db;
	  } 
	} break;
case 2:
# line 81 "dcalc.y"
{
		symtab_entry = mysymtab.lookupSymbol(get_symbol(yypvt[-2].str), 0);
		if (symtab_entry==NULL)
			printf("No such symbol %s in symbol table\n", yypvt[-2].str);
		if (symtab_entry!=NULL) 
		{
			if (symtab_entry->value.ch!=NULL) ;
			else
			  result = symtab_entry->value.db;
		}
		else
		{
			strcpy(symbol_value.ch, get_symbol(yypvt[-2].str));
 	        mysymtab.addSymbol(get_symbol(yypvt[-2].str), ATTR_VAR, 0, symbol_value, 0);
		}		    
	  
		if (yypvt[-0].str==NULL)
		{
			symtab_entry = mysymtab.lookupSymbol(get_symbol(yypvt[-2].str), 0);
			if (symtab_entry == NULL)
 				yyerror("NUMBER can not appear at the left side of =", 0, 0);	
			else
			{
				symtab_entry->attribute = ATTR_VAR;  
				symtab_entry->type = TYPE_DOUBLE;
				symtab_entry->value.db = yypvt[-0].db;
				yypvt[-2].db = yypvt[-0].db;
				yyval.db = yypvt[-0].db;
				result = yypvt[-0].db;
			}
		}
		else if (yypvt[-0].str!=NULL)
		{
			if (sqrt_flag==1)
			{
				symtab_entry = mysymtab.lookupSymbol(get_symbol(yypvt[-2].str), 0);
				if (symtab_entry == NULL)
 					yyerror("NUMBER can not appear at the left side of =", 0, 0);	
				else
				{
					symtab_entry->attribute = ATTR_VAR;  
					symtab_entry->type = TYPE_DOUBLE;
					symtab_entry->value.db = yypvt[-0].db;
					yypvt[-2].db = yypvt[-0].db;
					yyval.db = yypvt[-0].db;
					result = yypvt[-0].db;
				}
			}
			else
			{
				symtab_entry = mysymtab.lookupSymbol(yypvt[-0].str, 0);
				if (symtab_entry==NULL)
					printf("IDENTIFIER at the right side of = can not be found in symbol table\n");
				else
				{
					if (strlen(symtab_entry->value.ch)!=0)  
						; /* no value associated with */
					else
					{
						yypvt[-2].db = symtab_entry->value.db;
						yyval.db = yypvt[-2].db;
						result = yypvt[-2].db;
						symtab_entry = mysymtab.lookupSymbol(yypvt[-2].str, 0);
						symtab_entry->attribute = ATTR_VAR;
						symtab_entry->type = TYPE_DOUBLE;
						symtab_entry->value.db = yypvt[-2].db;
					}
				}
			}
		}
	} break;
case 3:
# line 156 "dcalc.y"
{
		if (yypvt[-1].str!=NULL)
		{
			symtab_entry = mysymtab.lookupSymbol(get_symbol(yypvt[-1].str), 0);
			if (symtab_entry==NULL)
				printf("IDENTIFIER at the right side of = can not be found in symbol table\n");
			else
			{
				if (strlen(symtab_entry->value.ch)!=0)
				{  
					yyval.db  = symtab_entry->value.db; /* no value associated with */
					sqrt_flag = 1;
				}
				else
				{
					sqrt_flag = 1;
					yyval.db = sqrt(symtab_entry->value.db);
					result = yyval.db;
				}
			}
		}
		else
		{
			if (yypvt[-1].db<0)
			{
				yyerror("The content of SQRT is negative value.", 0, 0);
				sqrt_neg = 1; 
			}
			else
			{
				sqrt_flag = 1;
				yyval.db = sqrt(yypvt[-1].db);
			}
		}
	} break;
case 4:
# line 192 "dcalc.y"
{ 
		/*$$.db = $1.db + $3.db; */
		if (sqrt_flag==1)
			yyval.db = yypvt[-2].db + yypvt[-0].db;
		else if (yypvt[-2].str==NULL && yypvt[-0].str==NULL) /* NUMBER+NUMBER */
		{
			yyval.db = yypvt[-2].db + yypvt[-0].db;
		}
		else if (yypvt[-2].str==NULL && strlen(yypvt[-0].str)!=0) /* NUMBER+IDENTIFIER */
		{
			symtab_entry = mysymtab.lookupSymbol(get_symbol(yypvt[-0].str), 0);
			if (symtab_entry==NULL)
				yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
			else
			{
				if (strlen(symtab_entry->value.ch)!=0)
				{
					yyerror("IDENTIFIER does not have value", 0, 0);
					idn_no_value = 1;
				}
				else
				{
					yypvt[-0].db = symtab_entry->value.db;
					yyval.db = yypvt[-2].db + yypvt[-0].db;
				}
			}
		}
		else if (strlen(yypvt[-2].str)!=0 && strlen(yypvt[-0].str)==0) /* IDENTIFIER+NUMBER */
		{
			symtab_entry = mysymtab.lookupSymbol(get_symbol(yypvt[-2].str), 0);
			if (symtab_entry==NULL)
				yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
			else
			{
				if (strlen(symtab_entry->value.ch)!=0)
				{
					yyerror("IDENTIFIER does not have value", 0, 0);
					idn_no_value = 1;
				}
				else
				{
					yypvt[-2].db = symtab_entry->value.db;
					yyval.db = yypvt[-2].db + yypvt[-0].db;
				}
			}
		}
		else if (strlen(yypvt[-2].str)!=0 && yypvt[-0].str!=NULL) /* IDENTIFIER+IDENTIFIER */
		{
			symtab_entry = mysymtab.lookupSymbol(get_symbol(yypvt[-2].str), 0);
			if (symtab_entry==NULL)
				yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
			else
			{
				if (strlen(symtab_entry->value.ch)!=0)
				{
					yyerror("IDENTIFIER does not have value", 0, 0);
					idn_no_value = 1;
				}
				else
				{
					yypvt[-2].db = symtab_entry->value.db;
					symtab_entry = mysymtab.lookupSymbol(get_symbol(yypvt[-0].str), 0);
					if (symtab_entry==NULL)
						yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
					else
					{
						if (strlen(symtab_entry->value.ch)!=0)
						{
							yyerror("IDENTIFIER does not have value", 0, 0);
							idn_no_value = 1;
						}
						else
						{
							yypvt[-0].db = symtab_entry->value.db;
							yyval.db = yypvt[-2].db + yypvt[-0].db;
						}
					}
				}
			}
		}
	} break;
case 5:
# line 274 "dcalc.y"
{ 
		/*$$.db = $1.db - $3.db;*/ 
		if (yypvt[-2].str==NULL && yypvt[-0].str==NULL) /* NUMBER-NUMBER */
		{
			yyval.db = yypvt[-2].db - yypvt[-0].db;
		}
		else if (yypvt[-2].str==NULL && yypvt[-0].str!=NULL) /* NUMBER-IDENTIFIER */
		{
			symtab_entry = mysymtab.lookupSymbol(get_symbol(yypvt[-0].str), 0);
			if (symtab_entry==NULL)
				yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
			else
			{
				if (symtab_entry->value.ch!=NULL)
				{
					yyerror("IDENTIFIER does not have value", 0, 0);
					idn_no_value = 1;
				}
				else
				{
					yypvt[-0].db = symtab_entry->value.db;
					yyval.db = yypvt[-2].db - yypvt[-0].db;
				}
			}
		}
		else if (yypvt[-2].str!=NULL && yypvt[-0].str==NULL) /* IDENTIFIER-NUMBER */
		{
			symtab_entry = mysymtab.lookupSymbol(get_symbol(yypvt[-2].str), 0);
			if (symtab_entry==NULL)
				yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
			else
			{
				if (symtab_entry->value.ch!=NULL)
				{
					yyerror("IDENTIFIER does not have value", 0, 0);
					idn_no_value = 1;
				}
				else
				{
					yypvt[-2].db = symtab_entry->value.db;
					yyval.db = yypvt[-2].db - yypvt[-0].db;
				}
			}
		}
		else if (yypvt[-2].str!=NULL && yypvt[-0].str!=NULL) /* IDENTIFIER-IDENTIFIER */
		{
			symtab_entry = mysymtab.lookupSymbol(get_symbol(yypvt[-2].str), 0);
			if (symtab_entry==NULL)
				yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
			else
			{
				if (symtab_entry->value.ch!=NULL)
				{
					yyerror("IDENTIFIER does not have value", 0, 0);
					idn_no_value = 1;
				}
				else
				{
					yypvt[-2].db = symtab_entry->value.db;
					symtab_entry = mysymtab.lookupSymbol(get_symbol(yypvt[-0].str), 0);
					if (symtab_entry==NULL)
						yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
					if (symtab_entry->value.ch!=NULL)
					{
						yyerror("IDENTIFIER does not have value", 0, 0);
						idn_no_value = 1;
					}
					else
					{
						yypvt[-0].db = symtab_entry->value.db;
						yyval.db = yypvt[-2].db - yypvt[-0].db;
					}
				}
			}
		}
	} break;
case 6:
# line 351 "dcalc.y"
{ 
		/*$$.db = $1.db * $3.db;*/ 
		if (yypvt[-2].str==NULL && yypvt[-0].str==NULL) /* NUMBER*NUMBER */
		{
			yyval.db = yypvt[-2].db * yypvt[-0].db;
		}
		else if (yypvt[-2].str==NULL && yypvt[-0].str!=NULL) /* NUMBER*IDENTIFIER */
		{
			symtab_entry = mysymtab.lookupSymbol(get_symbol(yypvt[-0].str), 0);
			if (symtab_entry==NULL)
				yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
			else
			{
				if (symtab_entry->value.ch!=NULL)
				{
					yyerror("IDENTIFIER does not have value", 0, 0);
					idn_no_value = 1;
				}
				else
				{
					yypvt[-0].db = symtab_entry->value.db;
					yyval.db = yypvt[-2].db * yypvt[-0].db;
				}
			}
		}
		else if (yypvt[-2].str!=NULL && yypvt[-0].str==NULL) /* IDENTIFIER*NUMBER */
		{
			symtab_entry = mysymtab.lookupSymbol(get_symbol(yypvt[-2].str), 0);
			if (symtab_entry==NULL)
				yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
			else
			{
				if (symtab_entry->value.ch!=NULL)
				{
					yyerror("IDENTIFIER does not have value", 0, 0);
					idn_no_value = 1;
				}
				else
				{
					yypvt[-2].db = symtab_entry->value.db;
					yyval.db = yypvt[-2].db * yypvt[-0].db;
				}
			}
		}
		else if (yypvt[-2].str!=NULL && yypvt[-0].str!=NULL) /* IDENTIFIER*IDENTIFIER */
		{
			symtab_entry = mysymtab.lookupSymbol(get_symbol(yypvt[-2].str), 0);
			if (symtab_entry==NULL)
				yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
			else
			{
				if (symtab_entry->value.ch!=NULL)
				{
					yyerror("IDENTIFIER does not have value", 0, 0);
					idn_no_value = 1;
				}
				else
				{
					yypvt[-2].db = symtab_entry->value.db;
					symtab_entry = mysymtab.lookupSymbol(get_symbol(yypvt[-0].str), 0);
					if (symtab_entry==NULL)
						yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
					if (symtab_entry->value.ch!=NULL)
					{
						yyerror("IDENTIFIER does not have value", 0, 0);
						idn_no_value = 1;
					}
					else
					{
						yypvt[-0].db = symtab_entry->value.db;
						yyval.db = yypvt[-2].db * yypvt[-0].db;
					}
				}
			}
		}
	} break;
case 7:
# line 428 "dcalc.y"
{
		if (yypvt[-0].db==0)
		{
			yyerror("divided by zero", 0, 0);
			div_zero = 1;
		}
		else
		{
			/*$$.db = $1.db / $3.db;*/
			if (yypvt[-2].str==NULL && yypvt[-0].str==NULL) /* NUMBER/NUMBER */
			{
				yyval.db = yypvt[-2].db / yypvt[-0].db;
			}
			else if (yypvt[-2].str==NULL && yypvt[-0].str!=NULL) /* NUMBER/IDENTIFIER */
			{
				symtab_entry = mysymtab.lookupSymbol(get_symbol(yypvt[-0].str), 0);
				if (symtab_entry==NULL)
					yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
				else
				{
					if (symtab_entry->value.ch!=NULL)
					{
						yyerror("IDENTIFIER does not have value", 0, 0);
						idn_no_value = 1;
					}
					else
					{
						yypvt[-0].db = symtab_entry->value.db;
						yyval.db = yypvt[-2].db / yypvt[-0].db;
					}
				}
			}
			else if (yypvt[-2].str!=NULL && yypvt[-0].str==NULL) /* IDENTIFIER/NUMBER */
			{
				symtab_entry = mysymtab.lookupSymbol(get_symbol(yypvt[-2].str), 0);
				if (symtab_entry==NULL)
					yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
				else
				{
					if (symtab_entry->value.ch!=NULL)
					{
						yyerror("IDENTIFIER does not have value", 0, 0);
						idn_no_value = 1;
					}
					else
					{
						yypvt[-2].db = symtab_entry->value.db;
						yyval.db = yypvt[-2].db / yypvt[-0].db;
					}
				}
			}
			else if (yypvt[-2].str!=NULL && yypvt[-0].str!=NULL) /* IDENTIFIER/IDENTIFIER */
			{
				symtab_entry = mysymtab.lookupSymbol(get_symbol(yypvt[-2].str), 0);
				if (symtab_entry==NULL)
					yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
				else
				{
					if (symtab_entry->value.ch!=NULL)
					{
						yyerror("IDENTIFIER does not have value", 0, 0);
						idn_no_value = 1;
					}
					else
					{
						yypvt[-2].db = symtab_entry->value.db;
						symtab_entry = mysymtab.lookupSymbol(get_symbol(yypvt[-0].str), 0);
						if (symtab_entry==NULL)
							yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
						if (symtab_entry->value.ch!=NULL)
						{
							yyerror("IDENTIFIER does not have value", 0, 0);
							idn_no_value = 1;
						}
						else
						{
							yypvt[-0].db = symtab_entry->value.db;
							yyval.db = yypvt[-2].db / yypvt[-0].db;
						}
					}
				}
			}
		}
	} break;
case 8:
# line 513 "dcalc.y"
{ 
		/* $$.db = -$2.db; */
		if (yypvt[-0].str==NULL)     /* expr is NUMBER */
		{
			yyval.db = -yypvt[-0].db;
		}
		else					/* expr is IDENTIFIER */ 
		{
			symtab_entry = mysymtab.lookupSymbol(get_symbol(yypvt[-0].str), 0);
			if (symtab_entry==NULL)
				yyerror("IDENTIFIER can not be found in symbol table", 0, 0);
			else
			{
				if (symtab_entry->value.ch!=NULL)
				{
					yyerror("IDENTIFIER does not have value", 0, 0);
					idn_no_value = 1;
				}
				else
				{
					yypvt[-0].db = symtab_entry->value.db;
  					yyval.db = -yypvt[-0].db;
				}
			}
		} 
	} break;
case 9:
# line 539 "dcalc.y"
{ yyval.db = yypvt[-1].db; } break;
case 10:
# line 541 "dcalc.y"
{ 
		yyval.db = yypvt[-0].db;
		symbol_value.db = yypvt[-0].db;
	} break;
case 11:
# line 546 "dcalc.y"
{
		symtab_entry = mysymtab.lookupSymbol(get_symbol(yypvt[-0].str), 0);
		if (symtab_entry==NULL)
			printf("No such symbol %s in symbol table\n", yypvt[-0].str);
		if (symtab_entry!=NULL) 
		{
			if (strlen(symtab_entry->value.ch)!=0)
			{
				idn_no_value = 1; 
				strcpy(yyval.str, yypvt[-0].str);
			}
			else
				yyval.db = symtab_entry->value.db;
		}
		else
		{
			idn_no_value = 1;
		    strcpy(symbol_value.ch, yypvt[-0].str);
			/*strcpy($$.str, $1.str);*/
 	        mysymtab.addSymbol(get_symbol(yypvt[-0].str), ATTR_VAR, 0, symbol_value, 0);
		}		    
	} break; 
    }
    goto enstack;
}

/* This function will return the count of errors for a parser that is
generated by yyParse().
*/     
int ABXYacc::get_yyErrorCount(void)
{
	  return yyErrorCount;
}
				 
/* This function serves the purpose to allow a parser to choose 
the lexer function which provides tokens. The lexer function is 
specified as a ppinter to an integer function. The function will 
be called by the parser function.
*/   
void ABXYacc::yySetLexer(ABXLex *LexObject)
{
	lexObject = LexObject;
	yyToken = -1;
}

/* This function will modify the token stack size based on the input size
provided by user. It is a very important feature so that user can modify 
YACC buffer size to meat th eproject requirement.
*/
void ABXYacc::yySetTokStack(int stack_size)
{
	delete[] yyValueStack;
	delete[] redSequence;
	yyValueStack = new YYSTYPE[stack_size];
	redSequence = new int[stack_size];
}