%{
#include <stdlib.h> 

#define STAND_ALONE 1	/* requested by pcltool to identify 
						stand-alone lexer */

private static int nchar = 0;	/* # of characters in file */
private static int nword = 0;	/* # of words in file */
private static int nline = 0;	/* # of lines in file */
%}

%%

\n              { 
				  nchar += 2;
                  ++nline;	/* line boundary in MS-DOS is CR LF */
				}

[^ \t\n]+       {
                  ++nword;
				  nchar += yyleng;
				}

.               ++nchar;

%%


    /* declare input stream */
    private static String yy_input_file_name; /* hold input file name */

    public static void main(String args[])
    {
      if (args.length == 0)
	  {
	    System.out.println("Can not find input file name.");
	    System.exit(-1);
	  }

      if (args.length>1)
	  {
	    System.out.println("Nonmeaningful arguments.");
	    System.exit(-1);
	  }

	  if (args.length==1)
	  {
	    yy_input_file_name = args[0];
	  }

      try {
        lex_fis = new FileInputStream(yy_input_file_name);
	  } 
	  catch (FileNotFoundException fnfe)
	  {
	    System.err.println(fnfe);
	    System.exit(-1);
	  }

	  yylex();
	  System.out.println("Summary:"+nchar+"\t"+nword+"\t"+nline);
	  System.exit(0);

    }
